#include "stdafx.h"
#include "NPFileData.h"

CNPFileData::CNPFileData(LPCTSTR pszcFilePath)
{
	m_hFile = CreateFile(pszcFilePath, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, NULL);	
}

CNPFileData::~CNPFileData(void)
{
	if (INVALID_HANDLE_VALUE != m_hFile)
	{
		CloseHandle(m_hFile);	
	}
}




void CNPFileData::Seek(unsigned long lSeek)
{
	if (INVALID_HANDLE_VALUE != m_hFile)
	{
		SetFilePointer(m_hFile, lSeek, NULL, FILE_BEGIN);		
	}
}
	
int	CNPFileData::ReadData(BYTE *pBuffer, unsigned long lBufferSize)
{
	if (INVALID_HANDLE_VALUE != m_hFile)
	{
		DWORD dwReadByte;
		BOOL bResult = ReadFile(m_hFile, pBuffer, lBufferSize, &dwReadByte, NULL);
		(bResult);
		return dwReadByte;	
	}
	return  0;
}
	
void CNPFileData::GetLong (unsigned long & lLong)
{
	if (INVALID_HANDLE_VALUE != m_hFile)
	{
		unsigned long lLow;
		GetShort(lLow);
		
		unsigned long lHigh;
		GetShort(lHigh);
			
		lLow += lHigh << 16;
		lLong = lLow;	
	}
}
	
void CNPFileData::GetShort (unsigned long & lLong)
{
	if (INVALID_HANDLE_VALUE != m_hFile)
	{
		int i;
		
		GetByte(i);
		unsigned long lLow = (unsigned long)i;
		GetByte(i);
		lLow += ((unsigned long)i)<<8;
   		lLong = lLow;
	}
}
	
void CNPFileData::GetByte(int & nInt)
{
	if (INVALID_HANDLE_VALUE != m_hFile)
	{
		DWORD dwReadByte;
		unsigned char c;
		ReadFile(m_hFile, &c, 1, &dwReadByte, NULL);
		nInt = (int)c;  
	}
}

unsigned long CNPFileData::GetZipDataSize()
{
	if (INVALID_HANDLE_VALUE != m_hFile)
	{
		return GetFileSize(m_hFile, NULL);	
	}
	return 0;
}